package rlemaigr.classdiagrameditor;

import org.eclipse.jface.action.*;
import org.eclipse.ui.IWorkbenchActionConstants;

import org.eclipse.gef.*;
import org.eclipse.gef.ui.actions.ActionRegistry;
import org.eclipse.gef.ui.actions.GEFActionConstants;

import rlemaigr.classdiagrameditor.actions.*;

public class ContextMenuProviderImpl extends ContextMenuProvider
{
	private ActionRegistry actionRegistry;

	public ContextMenuProviderImpl(ActionRegistry ar, GraphicalViewer gv)
	{
		super(gv);
		actionRegistry = ar;
	}
	public void buildContextMenu(IMenuManager manager)
	{
		GEFActionConstants.addStandardActionGroups(manager);

		IAction action;

		action = actionRegistry.getAction(CreateAttributeAction.ID);
		if (action.isEnabled())
			manager.appendToGroup(GEFActionConstants.GROUP_REST, action);

		action = actionRegistry.getAction(CreateMethodAction.ID);
		if (action.isEnabled())
			manager.appendToGroup(GEFActionConstants.GROUP_REST, action);

		action = actionRegistry.getAction(IWorkbenchActionConstants.DELETE);
		if (action.isEnabled())
			manager.appendToGroup(GEFActionConstants.GROUP_EDIT, action);

		action = actionRegistry.getAction(GEFActionConstants.UNDO);
		manager.appendToGroup(GEFActionConstants.GROUP_UNDO, action);

		action = actionRegistry.getAction(GEFActionConstants.REDO);
		manager.appendToGroup(GEFActionConstants.GROUP_UNDO, action);
	}

}
