package rlemaigr.classdiagrameditor.actions;

import org.eclipse.gef.ui.actions.*;
import org.eclipse.gef.commands.*;
import org.eclipse.gef.*;
import org.eclipse.gef.requests.*;
import org.eclipse.ui.*;
import rlemaigr.classdiagrameditor.model.*;

import java.util.*;
import rlemaigr.classdiagrameditor.editparts.*;

public class CreateAttributeAction extends SelectionAction
{
	public static final String ID = "create attribute action";

	public CreateAttributeAction(IWorkbenchPart part)
	{
		super(part);
	}

	public void init()
	{
		setId(ID);
		setText("create attribute");
	}

	protected boolean calculateEnabled()
	{
		List list = getSelectedObjects();
		if (list.size() == 1)
		{
			Object obj = list.get(0);
			if (obj instanceof ClassEditPart)
			{
				return true;
			}
		}
		return false;
	}
	public void run()
	{
		System.out.println("action CreateAttributeAction performed");
		List list = getSelectedObjects();
		if (list.size() == 1)
		{
			Object obj = list.get(0);
			if (obj instanceof ClassEditPart)
			{
				ClassEditPart part = (ClassEditPart) obj;
				AttributeListEditPart attribpart = part.getAttributeListEditPart();
				CreateRequest req = new CreateRequest();
				req.setType(RequestConstants.REQ_CREATE);
				req.setFactory(new SimpleFactory(AttributeModel.class));
				Command command = attribpart.getCommand(req);
				if (command != null && getCommandStack() != null)
					getCommandStack().execute(command);
			}
		}
	}

}
