package rlemaigr.classdiagrameditor.commands;

import org.eclipse.gef.commands.*;
import rlemaigr.classdiagrameditor.model.*;
import org.eclipse.draw2d.geometry.*;
import org.eclipse.draw2d.*;

public class CreateBendpointCommand extends Command
{
	private Point location;
	private int index;
	private InheritanceModel model;
	private AbsoluteBendpoint bendpoint;
	
	public CreateBendpointCommand(InheritanceModel model, int index, Point location)
	{
		this.model = model;
		this.index = index;
		this.location = location;	
	}
	public void execute()
	{
		bendpoint = new AbsoluteBendpoint(location);
		bendpoint.setLocation(location);
		model.addBendpoint(bendpoint, index);
	}
	public void redo()
	{
		model.addBendpoint(bendpoint, index);
	}
	public void undo()
	{
		model.removeBendpoint(bendpoint);
	}
}
