package rlemaigr.classdiagrameditor.commands;

import org.eclipse.draw2d.geometry.*;
import rlemaigr.classdiagrameditor.model.*;
import org.eclipse.gef.commands.*;

public class DiagramElementChangeConstraintCommand extends Command
{
	private DiagramElementModel element;
	private Rectangle oldConstraint;
	private Rectangle newConstraint;
	
	public DiagramElementChangeConstraintCommand(DiagramElementModel element, Rectangle newConstraint)
	{
		this.newConstraint = newConstraint;
		this.element = element;		
	}
	
	public void execute()
	{
		oldConstraint = element.getConstraint();
		element.setConstraint(newConstraint);
	}
	public void redo()
	{
		element.setConstraint(newConstraint);
	}
	public void undo()
	{
		element.setConstraint(oldConstraint);
	}
}
