package rlemaigr.classdiagrameditor.commands;

import org.eclipse.gef.commands.*;
import rlemaigr.classdiagrameditor.model.*;

public class ListElementOrphanCommand extends Command
{
	private Object child;
	private ListModel list;
	private int oldIndex;

	public ListElementOrphanCommand(ListModel list, Object child)
	{
		this.child = child;
		this.list = list;
	}
	public void execute()
	{
		oldIndex = list.getIndexOf(child);
		list.removeElement(child);
	}
	public void redo()
	{
		list.removeElement(child);
	}
	public void undo()
	{
		list.addElement(child, oldIndex);
	}
}