package rlemaigr.classdiagrameditor.commands;

import org.eclipse.gef.commands.*;
import rlemaigr.classdiagrameditor.model.*;
import org.eclipse.draw2d.geometry.*;
import org.eclipse.draw2d.*;

public class MoveBendpointCommand extends Command
{
	private Point newLocation;
	private Point oldLocation;
	private int index;
	private InheritanceModel model;
	private AbsoluteBendpoint bendpoint;
	
	public MoveBendpointCommand(InheritanceModel model, int index, Point newLocation)
	{
		this.model = model;
		this.index = index;
		this.newLocation = newLocation;	
	}
	public void execute()
	{
		AbsoluteBendpoint bendpoint = (AbsoluteBendpoint) model.getBendpoint(index);
		oldLocation = bendpoint.getLocation();
		bendpoint = new AbsoluteBendpoint(newLocation);
		model.replaceBendpoint(index, bendpoint);
	}
	public void redo()
	{
		bendpoint = new AbsoluteBendpoint(newLocation);
		model.replaceBendpoint(index, bendpoint);
	}
	public void undo()
	{
		bendpoint = new AbsoluteBendpoint(oldLocation);
		model.replaceBendpoint(index, bendpoint);
	}
}