package rlemaigr.classdiagrameditor.commands;

import org.eclipse.gef.commands.*;
import rlemaigr.classdiagrameditor.model.*;

public class ReconnectSourceCommand extends Command
{
	private ClassModel newSource;
	private ClassModel oldSource;
	private InheritanceModel connection;
	
	public ReconnectSourceCommand(ClassModel newSource, InheritanceModel connection)
	{
		this.newSource = newSource;
		this.connection = connection;
	}
	public void execute()
	{
		oldSource = connection.getSource();
		connection.setSource(newSource);
	}
	public void redo()
	{
		connection.setSource(newSource);
	}
	public void undo()
	{
		connection.setSource(oldSource);
	}
}
