package rlemaigr.classdiagrameditor.editparts;

import rlemaigr.classdiagrameditor.figures.*;
import rlemaigr.classdiagrameditor.model.*;
import rlemaigr.classdiagrameditor.editpolicies.*;

import org.eclipse.draw2d.*;
import org.eclipse.gef.*;

import java.util.*;
import java.beans.*;

public class ClassEditPart extends DiagramElementEditPart implements NodeEditPart
{
	private ChopboxAnchor anchor;
	
	public IFigure createFigure()
	{
		IFigure fig = new ClassFigure();
		anchor = new ChopboxAnchor(fig);
		return fig;
	}
	public void refreshVisuals()
	{
		super.refreshVisuals();
		ClassFigure figure = (ClassFigure)getFigure();
		ClassModel model = (ClassModel)getModel();
		figure.setLabel(model.getName());
	}
	public List getModelChildren()
	{
		List children = new ArrayList();
		ClassModel model = (ClassModel)getModel();
		children.add(model.getAttributeList());
		children.add(model.getMethodList());
		return children;
	}
	public List getModelSourceConnections()
	{
		return ((ClassModel)getModel()).getSourceConnections();
	}
	public List getModelTargetConnections()
	{
		return ((ClassModel)getModel()).getTargetConnections();
	}
	public IFigure getContentPane()
	{
		return ((ClassFigure)getFigure()).getContentPane();
	}
	public MethodListEditPart getMethodListEditPart()
	{
		return (MethodListEditPart)getChildren().get(1);
	}
	public AttributeListEditPart getAttributeListEditPart()
	{
		return (AttributeListEditPart)getChildren().get(0);
	}
	public void propertyChange(PropertyChangeEvent ev)
	{
		if(ev.getPropertyName().equals(ClassModel.PROPERTY_NAME_CHANGED))
			refreshVisuals();
		else if(ev.getPropertyName().equals(ClassModel.PROPERTY_SOURCE_CONNECTIONS_CHANGED))
			refreshSourceConnections();
		else if(ev.getPropertyName().equals(ClassModel.PROPERTY_TARGET_CONNECTIONS_CHANGED))
			refreshTargetConnections();
			super.propertyChange(ev);
	}
	public ConnectionAnchor getSourceConnectionAnchor(ConnectionEditPart connection)
	{
		return anchor;
	}
	public ConnectionAnchor getTargetConnectionAnchor(ConnectionEditPart connection)
	{
		return anchor;
	}
	public ConnectionAnchor getSourceConnectionAnchor(Request request)
	{
		return anchor;
	}
	public ConnectionAnchor getTargetConnectionAnchor(Request request)
	{
		return anchor;
	}
	public void createEditPolicies()
	{
		super.createEditPolicies();
		installEditPolicy(EditPolicy.NODE_ROLE, new GraphicalNodeEditPolicyImpl());
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new ClassComponentEditPolicy(){});
	}
}
