package rlemaigr.classdiagrameditor.editparts;

import rlemaigr.classdiagrameditor.model.*;
import org.eclipse.draw2d.*;
import org.eclipse.draw2d.geometry.*;
import org.eclipse.gef.*;
import org.eclipse.gef.tools.*;
import rlemaigr.classdiagrameditor.editpolicies.*;
import java.beans.*;

public abstract class DiagramElementEditPart extends ObjectEditPart
{
	public void refreshVisuals()
	{
		super.refreshVisuals();
		refreshParentLayout();
	}
	public DragTracker getDragTracker(Request request)
	{
		return new DragEditPartsTracker(this);
	}
	public void propertyChange(PropertyChangeEvent ev)
	{
		super.propertyChange(ev);
		if(ev.getPropertyName().equals(DiagramElementModel.PROPERTY_CONSTRAINT_CHANGED))
			refreshParentLayout();
	}
	private void refreshParentLayout()
	{
		DiagramElementModel model = (DiagramElementModel)getModel();
		Rectangle constraint = model.getConstraint().getCopy();
		DiagramEditPart parent = (DiagramEditPart)getParent();
		IFigure parentContentPane = parent.getContentPane();
		LayoutManager parentLayoutManager = parentContentPane.getLayoutManager();
		parentLayoutManager.setConstraint(getFigure(), constraint);
		parentContentPane.revalidate();
	}
	public void createEditPolicies()
	{
		super.createEditPolicies();
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new ComponentEditPolicyForwardDelete(){});
	}
}
