package rlemaigr.classdiagrameditor.editparts;

import org.eclipse.draw2d.*;
import java.beans.*;
import rlemaigr.classdiagrameditor.model.*;
import rlemaigr.classdiagrameditor.editpolicies.*;
import org.eclipse.gef.*;
import org.eclipse.gef.editparts.*;
import org.eclipse.gef.editpolicies.*;

public class InheritanceEditPart extends AbstractConnectionEditPart implements PropertyChangeListener
{
	//private EditPart source;
	//private EditPart target;

	protected IFigure createFigure()
	{
		PolylineConnection fig = new PolylineConnection();
		fig.setLineWidth(2);
		PolygonDecoration dec = new PolygonDecoration();
		dec.setScale(20,5);
		fig.setTargetDecoration(dec);
		return fig;
	}
	protected void refreshVisuals()
	{
		Object constraint = ((InheritanceModel) getModel()).getConstraint();
		Connection fig = (Connection) getFigure();
		fig.setRoutingConstraint(constraint);
	}
	public void propertyChange(PropertyChangeEvent ev)
	{
		if (ev.getPropertyName().equals(InheritanceModel.PROPERTY_CONSTRAINT_CHANGED))
			refreshVisuals();
	}
	public void activate()
	{
		if (!isActive())
		{
			super.activate();
			((ObjectModel) getModel()).addPropertyChangeListener(this);
		}
	}
	public void deactivate()
	{
		super.deactivate();
		((ObjectModel) getModel()).removePropertyChangeListener(this);
	}
	public void createEditPolicies()
	{
		installEditPolicy(EditPolicy.CONNECTION_ENDPOINTS_ROLE, new ConnectionEndpointEditPolicy());
		installEditPolicy(EditPolicy.CONNECTION_BENDPOINTS_ROLE, new BendpointEditPolicyImpl());
		installEditPolicy(EditPolicy.CONNECTION_ROLE, new ConnectionEditPolicyImpl());
	}
}
