package rlemaigr.classdiagrameditor.editparts;

import rlemaigr.classdiagrameditor.figures.*;
import rlemaigr.classdiagrameditor.model.*;
import org.eclipse.draw2d.IFigure;
import rlemaigr.classdiagrameditor.editpolicies.*;
import org.eclipse.gef.*;
import java.util.*;
import java.beans.*;

public class MethodEditPart extends ObjectEditPart
{
	public IFigure createFigure()
	{
		return new MethodFigure();
	}
	public void refreshVisuals()
	{
		MethodFigure figure = (MethodFigure) getFigure();
		MethodModel model = (MethodModel) getModel();
		figure.setSignature(
			model.getVisibility(),
			model.getReturnType(),
			model.getIdentifier(),
			model.getParametersTypes());
	}
	public List getModelChildren()
	{
		return new ArrayList();
	}
	public void createEditPolicies()
	{
		super.createEditPolicies();
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new ComponentEditPolicyForwardDelete()
		{
		});
	}
	public void propertyChange(PropertyChangeEvent ev)
	{
		if (ev.getPropertyName().equals(AttributeModel.PROPERTY_SIGNATURE_CHANGED))
			refreshVisuals();
		else
			super.propertyChange(ev);
	}
}