package rlemaigr.classdiagrameditor.editpolicies;

import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.requests.*;
import org.eclipse.gef.editpolicies.*;
import org.eclipse.gef.commands.*;

public class ComponentEditPolicyForwardDelete extends ComponentEditPolicy
{
	protected Command getDeleteCommand(GroupRequest request)
	{
		Command childCommand = createDeleteCommand((GroupRequest) request);
		Command parentCommand = getParentDeleteCommand((GroupRequest) request);
		CompoundCommand com = new CompoundCommand();
		if (childCommand != null)
			com.add(childCommand);
		if (parentCommand != null)
			com.add(parentCommand);

		if (childCommand == null && parentCommand == null)
			return null;
		else
			return com;
	}
	protected Command getParentDeleteCommand(GroupRequest request)
	{
		request.setEditParts(getHost());
		request.setType(RequestConstants.REQ_DELETE_DEPENDANT);
		return getHost().getParent().getCommand(request);
	}
}
