package rlemaigr.classdiagrameditor.editpolicies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.*;
import org.eclipse.gef.requests.CreateConnectionRequest;
import org.eclipse.gef.requests.ReconnectRequest;
import rlemaigr.classdiagrameditor.model.*;
import rlemaigr.classdiagrameditor.editparts.*;
import rlemaigr.classdiagrameditor.commands.*;

public class GraphicalNodeEditPolicyImpl extends GraphicalNodeEditPolicy
{

	protected Command getConnectionCompleteCommand(CreateConnectionRequest request)
	{
		ClassModel target = (ClassModel)getHost().getModel();
		CreateConnectionCommand command = (CreateConnectionCommand) request.getStartCommand();
		command.setTarget(target); 
		return command;
	}

	protected Command getConnectionCreateCommand(CreateConnectionRequest request)
	{
		ClassModel source = (ClassModel)getHost().getModel();
		CreateConnectionCommand command = new CreateConnectionCommand(source,null); 
		request.setStartCommand(command);
		return command;
	}

	protected Command getReconnectTargetCommand(ReconnectRequest request)
	{
		InheritanceEditPart part = (InheritanceEditPart)request.getConnectionEditPart();
		InheritanceModel model = (InheritanceModel)part.getModel();
		ClassModel target = (ClassModel)getHost().getModel();
		return new ReconnectTargetCommand(target, model);
	}

	protected Command getReconnectSourceCommand(ReconnectRequest request)
	{
		InheritanceEditPart part = (InheritanceEditPart)request.getConnectionEditPart();
		InheritanceModel model = (InheritanceModel)part.getModel();
		ClassModel source = (ClassModel)getHost().getModel();
		return new ReconnectSourceCommand(source, model);
	}

}
