package rlemaigr.classdiagrameditor.editpolicies;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.requests.*;
import org.eclipse.gef.commands.*;
import org.eclipse.gef.requests.CreateRequest;
import rlemaigr.classdiagrameditor.model.*;
import rlemaigr.classdiagrameditor.commands.*;
import rlemaigr.classdiagrameditor.editparts.*;
import java.util.*;

public class ToolbarLayoutEditPolicyImpl extends ToolbarLayoutEditPolicy
{

	protected Command createAddCommand(EditPart child, EditPart after)
	{
		if ((getHost() instanceof AttributeListEditPart
			&& child instanceof AttributeEditPart)
			|| (getHost() instanceof MethodListEditPart
				&& child instanceof MethodEditPart))
		{
			Object childModel = child.getModel();
			Object afterModel = (after == null) ? null : after.getModel();
			ListModel list = (ListModel) getHost().getModel();
			return new ListElementAddCommand(list, childModel, afterModel);
		}
		else
			return null;
	}
	protected Command getOrphanChildrenCommand(Request request)
	{
		CompoundCommand cc = new CompoundCommand();
		ListModel list = (ListModel) getHost().getModel();
		Iterator it = ((GroupRequest) request).getEditParts().iterator();
		while (it.hasNext())
		{
			cc.add(
				new ListElementOrphanCommand(
					list,
					((EditPart) it.next()).getModel()));
		}
		return cc;
	}
	protected Command createMoveChildCommand(EditPart child, EditPart after)
	{
		Object childModel = child.getModel();
		Object afterModel = (after == null) ? null : after.getModel();
		ListModel list = (ListModel) getHost().getModel();
		return new ListElementChangeConstraintCommand(
			list,
			childModel,
			afterModel);
	}

	protected Command getCreateCommand(CreateRequest request)
	{
		if (getHost() instanceof MethodListEditPart)
		{
			Object newObj = request.getNewObject();
			if (newObj instanceof MethodModel)
			{
				MethodModel newMethod = (MethodModel) newObj;
				ListModel list = (ListModel) getHost().getModel();
				return new CreateMethodCommand(list, newMethod);
			}
		}
		else
		{
			Object newObj = request.getNewObject();
			if (newObj instanceof AttributeModel)
			{
				AttributeModel newAttribute = (AttributeModel) newObj;
				ListModel list = (ListModel) getHost().getModel();
				return new CreateAttributeCommand(list, newAttribute);
			}
		}
		return null;
	}

	protected Command getDeleteDependantCommand(Request request)
	{
		CompoundCommand cc = new CompoundCommand();
		ListModel list = (ListModel) getHost().getModel();
		Iterator it = ((GroupRequest) request).getEditParts().iterator();
		while (it.hasNext())
		{
			cc.add(
				new ListElementDeleteCommand(
					list,
					((EditPart) it.next()).getModel()));
		}
		return cc;
	}

}
