package rlemaigr.classdiagrameditor.editpolicies;

import org.eclipse.draw2d.geometry.*;
import org.eclipse.gef.commands.*;
import org.eclipse.gef.requests.*;
import org.eclipse.gef.*;
import org.eclipse.gef.editpolicies.*;
import org.eclipse.gef.requests.CreateRequest;
import rlemaigr.classdiagrameditor.model.*;
import rlemaigr.classdiagrameditor.commands.*;
import java.util.*;

public class XYLayoutEditPolicyImpl extends XYLayoutEditPolicy
{
	protected Command createAddCommand(EditPart child, Object constraint)
	{
		return null;
	}

	protected Command createChangeConstraintCommand(EditPart child, Object constraint)
	{
		Rectangle rect = (Rectangle)constraint;
		DiagramElementModel model = (DiagramElementModel)child.getModel();
		return new DiagramElementChangeConstraintCommand(model, (Rectangle)constraint);
	}

	protected Command getCreateCommand(CreateRequest request)
	{
		Object newObj = request.getNewObject();
		if(newObj instanceof ClassModel)
		{
			ClassModel newClass = (ClassModel)newObj;
			DiagramModel diagram = (DiagramModel)getHost().getModel();
			Rectangle rect = (Rectangle)getConstraintFor(request);
			return new CreateClassCommand(diagram, newClass, rect.getLocation(), rect.getSize());
			//return new CreateClassCommand(diagram, newClass, request.getLocation(), request.getSize());
		}
		return null;
	}

	protected Command getDeleteDependantCommand(Request request)
	{
		CompoundCommand cc = new CompoundCommand();
		DiagramModel diagram = (DiagramModel)getHost().getModel();
		Iterator it = ((GroupRequest) request).getEditParts().iterator();
		while(it.hasNext())
		{
			cc.add(
				new DiagramElementDeleteCommand(
					diagram,
					(DiagramElementModel)((EditPart)it.next()).getModel()) );
		}
		return cc;
	}

}
