package rlemaigr.classdiagrameditor.figures;

import org.eclipse.draw2d.*;
import org.eclipse.draw2d.geometry.*;

public class ListFigure extends Figure
{
	private int spacing;
	private ToolbarLayout layout;
	private LabeledBorder border;
	
	public ListFigure()
	{
		super();
		//bord:
		border = createBorder();
		setBorder(border);
		
		//layout:
		layout = new ToolbarLayout(ToolbarLayout.VERTICAL);
		layout.setStretchMinorAxis(true);
		layout.setMinorAlignment(ToolbarLayout.ALIGN_TOPLEFT);
		spacing = 1;
		layout.setSpacing(spacing);
		setLayoutManager(layout);
	}
	public void setLabel(String label)
	{
		border.setLabel(label);
		revalidate();
		repaint();
	}
	public void setSpacing(int spacing)
	{
		this.spacing = spacing;
		layout.setSpacing(spacing);
		revalidate();
	}
	public LabeledBorder createBorder()
	{
		ListFigureBorder b = new ListFigureBorder();
		b.setColor(ColorConstants.blue);
		return b;
		//return new GroupBoxBorder();
	}
	public Dimension getMinimumSize(int w, int h) {
			return new Dimension(0,0);
		}
}